using System.ComponentModel;
using System.Diagnostics;

namespace Trek_12.Views;

using Models.Game;

public partial class PageBoard : ContentPage
{
    public Game GameManager => (App.Current as App).Manager;

    public PageBoard()
	{
		InitializeComponent();
        GameManager.DiceRolled += TheGame_DiceRolled;
        BindingContext = GameManager;

        // We add this game to the list of games
        GameManager.AddGame(GameManager);
        GameManager.OnPropertyChanged(nameof(GameManager.Games));
        GameManager.SaveData();
    }

    private void TheGame_DiceRolled(object? sender, Models.Events.DiceRolledEventArgs e)
    {
        Dice1.Text = $"{e.Dice1Value}";
        Dice2.Text = $"{e.Dice2Value}";
    }

    private void OnOperationCellSelected(object sender, SelectionChangedEventArgs e)
    {
        Debug.WriteLine("OnOperationCellSelected"); // Debug
        if (e.CurrentSelection.Count > 0) // Si un lment est slectionn
        {
            var selectedCell = (OperationCell)e.CurrentSelection[0];
            if (selectedCell != null && !selectedCell.IsChecked)
            {
                selectedCell.Check();
                Debug.WriteLine("OperationCell at ({0}, {1}) is checked", selectedCell.X, selectedCell.Y); // Debug
            }
            ((CollectionView)sender).SelectedItem = null; // Dselectionne l'lment pour la CollectionView
        }
    }

    private void DiceButton_Clicked(object sender, EventArgs e)
    {
        GameManager.RollAllDice();
    }
}